//------------------------------------------------------------------------------
// Sunshine's Basic Import Table Viewer           May 2002
// Shows Import Table of PE file
// Coded for myself in order to understand Import Table better...
// Perhaps this source helps someone
// Questions, ideas etc. ? Mail me: Lloret01@gmx.de
// WEB : www.sunshine.2kx.de   <- please use this
// if it doesn't work: www.welcome.to/sun-shine
//                 or: http://you.are.at/sunshine
//------------------------------------------------------------------------------



program ImpViewer;

uses
  Windows,
  Messages,
  commdlg,
  classes, sysutils;

{$R DLG.RES}

const
  WindowHeight = 415;
  WindowWidth = 398;
  WindowHeight2 = 330;
  WindowWidth2 = 460;

var
  //OPENFILENAME
  ofn : OPENFILENAME;
  filterstring : LPCTSTR =
                 'Executable Files (*.exe, *.dll)'+#0+'*.exe;*.dll'+#0+
                 'All Files (*.*)'+#0+'*.*'+#0+#0;
  filename : array[0..MAX_PATH] of char;

  ofn2 : OPENFILENAME;
  filename2 : array[0..MAX_PATH] of char;
  filterstring2 : LPCTSTR =
                 'Text Files (*.txt)'+#0+'*.txt'+#0+
                 'All Files (*.*)'+#0+'*.*'+#0+#0;

  // variable to get section infos -> RVA calculating
  vir_offs, virsize : array[1..20] of DWORD;
  raw_offs, rawsize : array[1..20] of DWORD;
  charac :  DWORD;
  which_sec : Integer;
  doshead : DWORD = $00;
  elfanew : DWORD = $00;
  peheader : DWORD = $00;
  Imagebase : DWORD = $00;
  number_sec : byte;

  // variables for Import table and so on
  ImpdirRVA : DWORD = $00; // Import Directory RVA
  ImpdirSize : DWORD = $00; // Import Directory Size;
  OriFirstThunkRVA : DWORD = $00;
  FirstThunkRVA : DWORD = $00;
  NameRVA : DWORD = $00; // RVA to Name of DLL
  DllName : string;
  Hint1 : WORD = $00;
  ApiName : string;
  ordflag : DWORD = $00;  //var to check if function is imported by ordinal


// get needed info about the sections for RVA Calculating
function GetFileInfo(filename : string; dialog : HWND) : Integer;
var
  f : TFilestream;
  i : Integer;
begin
  f := TFileStream.Create(filename,fmopenreadwrite);
  f.seek(0,sofrombeginning);
  f.read(doshead,2);
  if doshead <> $5A4D then
  begin
     MessageBox(0,pchar('Not a valid PE File'),pchar('Error'),
                mb_iconinformation);
     f.Free;
     result := 0;
     exit;
  end;
  // File address of new Exe header
  f.Seek($3C,sofrombeginning);
  f.Read(elfanew,4);
  // PE Header
  f.Seek(elfanew,sofrombeginning);
  f.Read(peheader,2);
  if  not (peheader = $4550) then
  begin
     MessageBox(0,pchar('Not a valid PE File'),pchar('Error'),
                mb_iconinformation);
     f.Free;
     result := 0;
     exit;
  end;
  // Number of Sections
  f.seek(4,sofromcurrent);
  f.Read(number_sec,2);
  // Imagebase
  f.seek($2c,sofromcurrent);
  f.Read(Imagebase,4);
  // Section Info
  f.Seek(elfanew + $f8,sofrombeginning);
    for i := 1 to number_sec do
    begin
      f.seek(8, sofromcurrent);
      //Vir_size
      f.Read(virsize[i],4);
      // Virtual Adress
      f.Read(vir_offs[i],4);
      // Raw size
      f.Read(rawsize[i],4);
      // Raw Offset
      f.Read(raw_offs[i],4);
      // Characteristics
      f.seek(12,sofromcurrent);
      f.Read(charac,4);
    end;
  result := 1;  
  f.free;
end;

function RVA2Offset(va : DWORD; filename : string) : DWORD;
var
  i: Integer;
begin
  which_sec := 0;
  for i := 1 to number_Sec  do
  begin
    if (VA >= vir_offs[i]) and (va < vir_offs[i+1]) then
    begin
      which_sec := i;
      break;
    end;
    if i = number_Sec then
      if (VA <= (vir_offs[i] + virsize[i])) and (VA >= vir_offs[1])
      then
        which_sec := i
      else
      begin
        MessageBox(0,pchar('Not in file!'),pchar('Error'),mb_ok);
      end;
    end;

    result := VA - vir_offs[which_Sec] + raw_offs[which_Sec];
end;


procedure GetImportTable(filename : string; dialog : HWND);
var
  f : TFileStream;
   temp : Integer;
  d : DWORD;            // just a help variable
  count_api : Integer;  // counts how many functions from one dll are implented
  count_dll : Integer;  // counts how many dlls are imported
  listcount : Integer;  // help variable for clearing listbox
  s : string;
  p : pchar;
begin
  // First of all clear listbox
  repeat
    listcount := SendMessage(GetdlgItem(dialog,1001), LB_GETCOUNT, 0, 0);
    SendMessage(GetdlgItem(dialog,1001), LB_DELETESTRING, 0, 0);
  until (listcount = 0);

  p := pchar(filename);
  SendMessage(getdlgitem(dialog,1001), LB_INSERTSTRING, -1, Integer(p));
  f := TFileStream.Create(filename,fmopenreadwrite);
  f.Seek(elfanew + $80,sofrombeginning);
  f.Read(impdirRVA,4);
  f.Read(ImpDirSize,4);
  // Write Import Directory RVA
  s := 'ImportDirectory RVA: '+  inttohex(impDirRVA,8) +
        '    (Offset: ' + inttohex(RVA2Offset(impdirRVA,filename),8) + ')';
  p := pchar(s);
  SendMessage(getdlgitem(dialog,1001), LB_INSERTSTRING, -1, Integer(p));
  // Write Import Directory Size
  s := 'ImportDirectory Size: ' + inttohex(impdirSize,8);
  p := pchar(s);
  SendMessage(getdlgitem(dialog,1001), LB_INSERTSTRING, -1, Integer(p));

  count_dll := -1;
repeat         // loop through every data directory
  count_dll := count_dll + 1;
  f.Seek(RVA2Offset(impdirRVA,filename) + $c + $14*count_dll, sofrombeginning); // Name of DLL
  f.Read(NameRVA,4);
  if NameRVA = 0 then break;
  f.seek(RVA2Offset(NameRva,filename), sofrombeginning);
  Dllname := '';
  repeat
    f.Read(temp,1);
    DllName := Dllname + chr(temp);
  until temp = 0;

  s := '';
  p := pchar(s);
  SendMessage(getdlgitem(dialog,1001), LB_INSERTSTRING, -1, Integer(p));

  s := '-----------------------------------------------------------------------';
  p := pchar(s);
  SendMessage(getdlgitem(dialog,1001), LB_INSERTSTRING, -1, Integer(p));
  s := 'Dll: ' + Dllname;
  p := pchar(s);
  SendMessage(getdlgitem(dialog,1001), LB_INSERTSTRING, -1, Integer(p));

// -> At First read OriginalFirstThunk and FirstThunk
  f.Seek(RVA2Offset(impdirRVA,filename) + 0 + $14*count_dll, sofrombeginning);
  f.Read(OriFirstthunkRVA,4);
  f.Seek(RVA2Offset(impdirRVA,filename) + $10 + $14*count_dll, sofrombeginning);
  f.Read(FirstthunkRVA,4);

  // Write OriginalFirstThunk to Listbox
  if oriFirstThunkRva = 0 then
     s := 'OriginalFirstThunk RVA: ' + inttohex(orifirstthunkrva,8) + '  (Offset: '+
                    '0000)' else
     s := 'OriginalFirstThunk RVA: ' + inttohex(orifirstthunkrva,8) + '  (Offset: '+
                    inttohex(Rva2Offset(Orifirstthunkrva,filename),8) + ')';
  p := pchar(s);
  SendMessage(getdlgitem(dialog,1001), LB_INSERTSTRING, -1, Integer(p));
  // Write FirstThunk to Listbox
  s := 'FirstThunk RVA: ' + inttohex(firstthunkrva,8) + '    (Offset: '+
                    inttohex(Rva2Offset(firstthunkrva,filename),8) + ')';
  p := pchar(s);
  SendMessage(getdlgitem(dialog,1001), LB_INSERTSTRING, -1, Integer(p));


  if OriFirstthunkRVA <> 0 then  // OriginalFirstThunk is available, so use it!
  begin
    firstThunkRVA := OriFirstThunkRVA;
  end;




  p := pchar('');
  SendMessage(getdlgitem(dialog,1001), LB_INSERTSTRING, -1, Integer(p));
  Count_Api := -1;
  repeat // All Functions from DLL
    Count_Api := Count_Api + 1;
    f.seek(RVA2Offset(FirstthunkRVA,filename) + Count_api*4, sofrombeginning);

    f.read(d,4);
    if d = $00000000 then break;

    ordflag := $00000000;
    //check for ordinal import
    f.seek(RVA2Offset(FirstthunkRVA,filename) + Count_api*4 +2, sofrombeginning);
    f.Read(ordflag,2);

    if ordflag = $8000 then
    begin
      f.seek(RVA2Offset(FirstthunkRVA,filename) + Count_api*4, sofrombeginning);
      f.Read(Hint1,2);
      s := '-imported by ordinal-   (Hint: ' + inttohex(hint1,4)+')';
      p := pchar(s);
      SendMessage(getdlgitem(dialog,1001), LB_INSERTSTRING, -1, Integer(p));
    end
    else
    begin

    f.seek(RVA2Offset(d,filename), sofrombeginning);
    f.Read(Hint1,2);

    //imported by name
      ApiName := '';
      repeat
        f.Read(temp,1);
        ApiName := Apiname + chr(temp);
      until temp = 0;
      delete(apiname,length(apiname),1);
      s := Apiname + '       (Hint: '+ inttohex(hint1,4) + ')';
      p := pchar(s);
      SendMessage(getdlgitem(dialog,1001), LB_INSERTSTRING, -1, Integer(p));

    end;
  until d = $0000;
 until (NameRVA = 0) or (FirstThunkRva = 0);

  f.free;

end;


procedure SaveAstext(filename : string; Dialog : HWND);
var
  f : Textfile;
  linecount, i : Integer;
  buffer : array[0..255] of char;
begin
  If not (ExtractFileExt(filename) = '.txt') then
     filename := filename + '.txt';

  linecount := SendMessage(getdlgitem(dialog,1001),LB_GETCOUNT, 0, 0);
  if linecount = 0 then exit;

  Assignfile(f, filename);
  Rewrite(f);
  for i := 0 to linecount-1 do
  begin
    SendMessage(getdlgitem(dialog,1001),LB_GETTEXT,i, Integer(@buffer));
    Writeln(f,buffer);
  end;
  ZeroMemory(@buffer,sizeof(buffer));
  Closefile(f);
end;

// ABOUT BOX
function DlgProc2(Dialog2: HWnd; Msg, WParam: Word; LParam: Longint): BOOL; stdcall;
var
  x,y : Integer;
  hfont : Integer;
  b: array[0..255] of Char;
begin
  case Msg of
  WM_CLOSE : EndDialog(dialog2,0);
  WM_INITDIALOG :
      begin
        x := GetSystemMetrics(SM_CXSCREEN);
        y := GetSystemMetrics(SM_CYSCREEN);
        MoveWindow(Dialog2, (x div 2) - (WindowWidth2 div 2),
                (y div 2) - (WindowHeight2 div 2),
                 WindowWidth2, WindowHeight2, true);

        B := '         ____________________________________________________';
        SendMessage(getdlgitem(dialog2,1000), LB_ADDSTRING, 0, Integer(@b));
        B := '        /    ______                 __    __                /|';
        SendMessage(getdlgitem(dialog2,1000), LB_INSERTSTRING, -1, Integer(@b));
        B := '       /    / ____/                / /   /_/               / /';
        SendMessage(getdlgitem(dialog2,1000), LB_INSERTSTRING, -1, Integer(@b));
        B := '      /    / /_____  _____________/ /________________     / /';
        SendMessage(getdlgitem(dialog2,1000), LB_INSERTSTRING, -1, Integer(@b));
        B := '     /    / __  / / / / __  /  __/ __  / / __  / ___/    / /';
        SendMessage(getdlgitem(dialog2,1000), LB_INSERTSTRING, -1, Integer(@b));
        B := '    /     ___/ / /_/ / / / /__  / / / / / / / / ___/    / /';
        SendMessage(getdlgitem(dialog2,1000), LB_INSERTSTRING, -1, Integer(@b));
        B := '   /    /_____/_____/_/ /_/____/_/ /_/_/_/ /_/____/    / /';
        SendMessage(getdlgitem(dialog2,1000), LB_INSERTSTRING, -1, Integer(@b));
        B := '  /                                                   / /';
        SendMessage(getdlgitem(dialog2,1000), LB_INSERTSTRING, -1, Integer(@b));
        B := ' /___________________________________________________/ /';
        SendMessage(getdlgitem(dialog2,1000), LB_INSERTSTRING, -1, Integer(@b));
        B := ' \____________________________________________________/';
        SendMessage(getdlgitem(dialog2,1000), LB_INSERTSTRING, -1, Integer(@b));

        B := '';
        SendMessage(getdlgitem(dialog2,1000), LB_INSERTSTRING, -1, Integer(@b));
        B := ' coded with Delphi 5       May 22nd, 2002';
        SendMessage(getdlgitem(dialog2,1000), LB_INSERTSTRING, -1, Integer(@b));
        B := ' Mail: Lloret01@gmx.de          (Write me if you have questions!';
        SendMessage(getdlgitem(dialog2,1000), LB_INSERTSTRING, -1, Integer(@b));
        B := ' WEB : www.sunshine.2kx.de      (Please use this URL)';
        SendMessage(getdlgitem(dialog2,1000), LB_INSERTSTRING, -1, Integer(@b));
        B := '       www.welcome.to/sun-shine (if the other doesn' + #39+ 'not work...';
        SendMessage(getdlgitem(dialog2,1000), LB_INSERTSTRING, -1, Integer(@b));
        B := '';
        SendMessage(getdlgitem(dialog2,1000), LB_INSERTSTRING, -1, Integer(@b));
        B := '             ----===  DELPHI RULEZ  ===----';
        SendMessage(getdlgitem(dialog2,1000), LB_INSERTSTRING, -1, Integer(@b));
        B := '                 SUNSHINE , MAY 2002';
        SendMessage(getdlgitem(dialog2,1000), LB_INSERTSTRING, -1, Integer(@b));

        hFont := CreateFont(14, 0, 0, 0, 400, 0, 0, 0, DEFAULT_CHARSET,
           OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,DEFAULT_PITCH
           or FF_DONTCARE, 'Courier New');
        SendMessage(getdlgitem(dialog2,1000),WM_Setfont,hfont,0);
        Closehandle(hfont);
      end;

  WM_COMMAND :
    case wParam of
      1 : EndDialog(dialog2,0);
    end;
       
  end;
  DlgProc2 := false;
end;


function DlgProc(Dialog: HWnd; Msg, WParam: Word; LParam: Longint): BOOL; stdcall;
var
  x,y : Integer;
begin
  case Msg of
    WM_ClOSE : PostQuitMessage(0);
    WM_INITDIALOG :
      begin
        x := GetSystemMetrics(SM_CXSCREEN);
        y := GetSystemMetrics(SM_CYSCREEN);
        MoveWindow(Dialog, (x div 2) - (WindowWidth div 2),
                (y div 2) - (WindowHeight div 2),
                 WindowWidth, WindowHeight, true);
      end;

    WM_COMMAND :
    case wParam of
      1004 : PostQuitMessage(0);
      1000 : begin
               ofn.lStructSize := sizeof(ofn);
               ofn.hWndOwner := dialog;
               ofn.hInstance   := HInstance;
               ofn.lpstrFilter := filterstring;
               ofn.lpstrFile := filename;
               ofn.nMaxFile :=  512;
               ofn.lpstrTitle := 'Choose file...';
               ofn.Flags := OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_LONGNAMES or
                            OFN_EXPLORER or OFN_HIDEREADONLY;
               if Getopenfilename(ofn) then
               begin
                 if Getfileinfo(filename, dialog) <> 0 then
                    GetImportTable(filename, dialog);
               end;
             end;

      1002 : begin
               ofn2.lStructSize := sizeof(ofn);
               ofn2.hWndOwner := dialog;
               ofn2.hInstance   := HInstance;
               ofn2.lpstrFilter := filterstring2;
               ofn2.lpstrFile := filename2;
               ofn2.nMaxFile :=  512;
               ofn2.lpstrTitle := 'Choose file...';
               ofn2.Flags := OFN_LONGNAMES or OFN_EXPLORER or OFN_HIDEREADONLY;
               if GetSaveFileName(ofn2) then
                begin
                  SaveAsText(filename2, dialog);
                  ZeroMemory(@filename2,sizeof(filename));
                end;
             end;

      1003 : DialogBoxParam(hInstance, PChar('ABOUTDLG'), 0, @DlgProc2, 0);



    end;

  end;

  DlgProc := false;
end;  

begin
  DialogBoxParam(hInstance, PChar('DLG'), 0, @DlgProc, 0);
  ExitProcess(hInstance);
end.
